c     -*- Fortran -*-
      subroutine cavini
      include 'cavity.inc'

      open(unit=l_log,name='cav.log',status='unknown')
      open(unit=l_meta,name='cav.ps',status='unknown')
      ierr=0

      DO 100 I=1,361
         SINT(I)=SIN((I-1)*DTOR)
         COST(I)=COS((I-1)*DTOR)
 100  CONTINUE
      do 101 i=1,MaxAtm
        iuse(i)=0
 101  continue
      call readcn
      call readdt
      DO 300 I=1,NATOM
        W(I)=VDW(ITBL(I))
        W2(I)=W(I)**2
 300  CONTINUE
      DO 310 I=1,NPLT
        L=IPLT(I)
        DO 320 J=1,NEXCL
          K=IEXCL(J)
          IF (L.EQ.K) GO TO 320
          DIST=(XYZ(1,L)-XYZ(1,K))**2+(XYZ(2,L)-XYZ(2,K))**2
     $        +(XYZ(3,L)-XYZ(3,K))**2
          W2(L)=AMIN1(DIST,W2(L))
 320    CONTINUE
        W(L)=SQRT(W2(L))
 310  CONTINUE
      WRITE (l_log,'(A6,I4,4F10.6)') (NATM(I),I,(XYZ(J,I),J=1,3),
     $	W(I),I=1,NATOM)      
      IF (DIVZ.LE.0.0) divz=0.2
      return
      end

c****************************************************************
c     initialize2
c     set initial range, axis

      subroutine cavin2
      include 'cavity.inc'
      KX=1
      KY=3
      KZ=IVIEW
      IF (IVIEW.EQ.1) KX=2
      IF (IVIEW.EQ.3) KY=2
      IF (NINT.eq.0) then 
         call setmin
      else
         XMIN=cmin(kx)
         XMAX=cmax(kx)
         YMIN=cmin(ky)
         YMAX=cmax(ky)
         ZMIN=cmin(kz)
         ZMAX=cmax(kz)
         write(l_log,'(8F10.6)') (cmin(i),cmax(i),i=1,3),DIVZ
      endif
      do 102 i=1,3
         cmin(i)=10000
         cmax(i)=-10000
 102  continue
      return
      end

c*****************************************************

c     -*- Fortran -*- 
      subroutine setmin
c
c     Setup Range Minimum/Maximum
c
      include 'cavity.inc'
      XMIN=XYZ(kx,IEXCL(1))
      XMAX=XYZ(kx,IEXCL(1))
      YMIN=XYZ(ky,IEXCL(1))
      YMAX=XYZ(ky,IEXCL(1))
      ZMIN=XYZ(kz,IEXCL(1))
      ZMAX=XYZ(kz,IEXCL(1))
      DO 2000 J=2,NEXCL
        IF (XYZ(kx,IEXCL(J)).LT.XMIN) XMIN=XYZ(kx,IEXCL(J))
        IF (XYZ(kx,IEXCL(J)).GT.XMAX) XMAX=XYZ(kx,IEXCL(J))
        IF (XYZ(ky,IEXCL(J)).LT.YMIN) YMIN=XYZ(ky,IEXCL(J))
        IF (XYZ(ky,IEXCL(J)).GT.YMAX) YMAX=XYZ(ky,IEXCL(J))
        IF (XYZ(kz,IEXCL(J)).LT.ZMIN) ZMIN=XYZ(kz,IEXCL(J))
        IF (XYZ(kz,IEXCL(J)).GT.ZMAX) ZMAX=XYZ(kz,IEXCL(J))
 2000 CONTINUE
      XMIN=XMIN-cadd
      XMAX=XMAX+cadd
      YMIN=YMIN-cadd
      YMAX=YMAX+cadd
      ZMIN=ZMIN-cadd
      ZMAX=ZMAX+cadd
      return
      end

c*****************************************************************
c
c     Cavity Final Message Print Routine
c     (Range, Step, Volume Print Out)
c
      subroutine cavfin
      include 'cavity.inc'
      do 10 i=1,3
        cmin(i)=cmin(i)-2*divz
        cmax(i)=cmax(i)+2*divz
 10   continue
      if (cmin(kx).lt.XMIN .or. nint.ne.0) cmin(kx)=XMIN
      if (cmax(kx).gt.XMAX .or. nint.ne.0) cmax(kx)=XMAX
      if (cmin(ky).lt.YMIN .or. nint.ne.0) cmin(ky)=YMIN
      if (cmax(ky).gt.YMAX .or. nint.ne.0) cmax(ky)=YMAX
      if (cmin(kz).lt.ZMIN .or. nint.ne.0) cmin(kz)=ZMIN
      if (cmax(kz).gt.ZMAX .or. nint.ne.0) cmax(kz)=ZMAX
      write(l_log,'(7h$ Range)')
      WRITE (l_log,1) (cmin(i),cmax(i),i=1,3),divz
    1 FORMAT ('     XMIN,     XMAX,     YMIN,     YMAX,     ZMIN,',
     $     '     ZMAX,     DIV',/,7F10.4)
      write(lbuf,'(9HXRANGE = ,2f10.4)')cmin(1),cmax(1)
      call plotcc(lbuf)
      write(lbuf,'(9HYRANGE = ,2f10.4)')cmin(2),cmax(2)
      call plotcc(lbuf)
      write(lbuf,'(9HZRANGE = ,2f10.4)')cmin(3),cmax(3)
      call plotcc(lbuf)
      if (ierr .eq. 0) then
        if (ivol.ne.0) then
          write(l_log,'(10hVolume =  ,f10.3)')vol
          write(lbuf,'(9HVolume = ,f8.3)')vol
          call plotcc(lbuf)
        else
          write(l_log,'(10hVolume =  ,f10.3)')-1.0
        end if
      else
        write(lbuf,'(A)')'Cavity Calculation Error'
        call plotcc(lbuf)
      end if
      call flush(l_log)
      write(l_log,'(9h$ CavAtom)')
      call used
      call flush(l_log)
      write(l_log,'(10h$ UsedAtom)')
      do 20 i=1,NPLT
        k=iplt(i)
        write(l_log,'(A6,I4,4F10.5)')NATM(k),ITBL(k),
     $      (XYZ(j,k),j=1,3),W(k)
 20   continue
      call flush(l_log)
      write(l_log,'(9h$ CavBond)')
      do 30 i=1,NBOND
        write(l_log,'(2(A6,1X,3F10.5,1X))') 
     $      natm(ips(i)),(xyz(j,ips(i)),j=1,3),
     $      natm(ipe(i)),(xyz(j,ipe(i)),j=1,3)
 30   continue
      write(l_log,'(5h$ End)')
      call flush(l_log)
      call plottr
      close(l_meta)
      close(l_log)
      return
      END

c********************************************************
      subroutine used
      include 'cavity.inc'
      do 10 i=1,NATOM
        if (iuse(i).eq.1) then
          write(l_log,'(A2,I4,4F10.6)') natm(i),i,
     $        (xyz(j,i),j=1,3),w(i)
        endif
 10   continue
      write(l_log,'(1h#)')
      do 20 i=1,NATOM
        if (iuse(i).eq.2) then
          write(l_log,'(A2,I4,4F10.6)') natm(i),i,
     $        (xyz(j,i),j=1,3),w(i)
        endif
 20   continue
      return
      end
